unit fFreeText;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmFreeText = class(TForm)
    txtSearch: TEdit;
    lblInstruct: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure txtSearchChange(Sender: TObject);
  private

  public
    class procedure InvokeEditor(var ACaption: string; ValueList: TStringList);
  end;

implementation

{$R *.DFM}

uses ORFn;

{ TfrmFreeText }

class procedure TfrmFreeText.InvokeEditor(var ACaption: string; ValueList: TStringList);
var
  frmFreeText: TfrmFreeText;
begin
  frmFreeText := TfrmFreeText.Create(Application);
  try
    ResizeAnchoredFormToFont(frmFreeText);
    if ValueList.Count > 0 then frmFreeText.txtSearch.Text := ValueList[0];
    if frmFreeText.ShowModal = mrOK then
    begin
      ACaption := frmFreeText.txtSearch.Text;
      ValueList.Clear;
      ValueList.Add(ACaption);
    end; {if ShowModal}
  finally
    frmFreeText.Release;
  end;
end;

procedure TfrmFreeText.btnOKClick(Sender: TObject);
begin
  Self.ModalResult := mrOK;
end;

procedure TfrmFreeText.btnCancelClick(Sender: TObject);
begin
  Self.ModalResult := mrCancel;
end;

procedure TfrmFreeText.txtSearchChange(Sender: TObject);
begin
  btnOK.Enabled := Length(txtSearch.Text) > 0;
end;

end.
