unit fPageDocuments;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, mQuery, ExtCtrls, ComCtrls;

type
  TfrmPageDocuments = class(TForm)
    pnlButtons: TPanel;
    Label2: TLabel;
    Splitter1: TSplitter;
    pnlQuery: TPanel;
    Label1: TLabel;
    fraNewQuery: TfraQuery;
    btnFinish: TButton;
    btnNext: TButton;
    btnBack: TButton;
    btnCancel: TButton;
    ProgressBar1: TProgressBar;
    Label3: TLabel;
    shpWizard: TShape;
    sbxWizard: TScrollBox;
    GroupBox1: TGroupBox;
    GroupBox4: TGroupBox;
    chkStatus: TCheckBox;
    chkAuthor: TCheckBox;
    chkLocation: TCheckBox;
    chkTypeClass: TCheckBox;
    chkTypeTitle: TCheckBox;
    Label4: TLabel;
    chkNoDocuments: TCheckBox;
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnFinishClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkCriterionClick(Sender: TObject);
  private
    FCreating: Boolean;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses ORFn, fHost, uReport, fpageSaveto;

const
  TX_REQ_TYPE = 'Document Class or Specific Titles must be checked to search for documents.';
  TC_REQ_TYPE = 'Required Criteria';

{ Create and Destroy ----------------------------------------------------------------------- }

procedure TfrmPageDocuments.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  FCreating := True;
  if frmHost.DriveByEdit then
    btnFinish.Enabled := True;
  for i := 0 to Pred(ComponentCount) do
  begin
    if Components[i].Tag = 0 then Continue;
    if not ((Components[i] is TCheckBox) or (Components[i] is TRadioButton)) then Continue;
    if Report.ContainsCriterion(Components[i].Tag) then
    begin
      if Components[i] is TCheckBox    then TCheckBox(Components[i]).Checked := True;
      if Components[i] is TRadioButton then TRadioButton(Components[i]).Checked := True;
    end;
  end;
  FCreating := False;
  fraNewQuery.BuildQuery;
end;

{ Control Events --------------------------------------------------------------------------- }

procedure TfrmPageDocuments.chkCriterionClick(Sender: TObject);
begin
  if FCreating then Exit;
  with Sender as TCheckBox do
  begin
    if Checked
      then Report.AddCriterion(Tag)
      else Report.RemoveCriterion(Tag);
  end;
  fraNewQuery.BuildQuery;
end;

{ Button Events ---------------------------------------------------------------------------- }

procedure TfrmPageDocuments.btnCancelClick(Sender: TObject);
begin
  Report.Clear;
  OldQuery.Clear;
  frmHost.DriveByEdit := False;  
  frmHost.SwitchTo(CONTENT_REPORTS);
end;

procedure TfrmPageDocuments.btnBackClick(Sender: TObject);
begin
  frmHost.WizardBack;
end;

procedure TfrmPageDocuments.btnNextClick(Sender: TObject);
begin
  if ShowMsgOn((not chkTypeClass.Checked) and (not chkTypeTitle.Checked),
                TX_REQ_TYPE, TC_REQ_TYPE) then Exit;
  frmHost.WizardNext;
end;

procedure TfrmPageDocuments.btnFinishClick(Sender: TObject);
begin
  frmHost.DriveByEdit := False;
  if IsGenericReport(Report.DisplayText) then
    SaveReportTo
  else
    SaveEditedReport;
  frmHost.SwitchTo(CONTENT_REPORTS);
end;

end.
