unit fPageOrders;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, mQuery, ORFn, rReport;

type
  TfrmPageOrders = class(TForm)
    Label2: TLabel;
    pnlButtons: TPanel;
    btnFinish: TButton;
    btnNext: TButton;
    btnBack: TButton;
    btnCancel: TButton;
    pnlQuery: TPanel;
    Label3: TLabel;
    fraNewQuery: TfraQuery;
    Splitter1: TSplitter;
    sbxWizard: TScrollBox;
    grpType: TGroupBox;
    radItemOrdered: TRadioButton;
    radItemOrderedCombo: TRadioButton;
    chkTypeText: TCheckBox;
    GroupBox3: TGroupBox;
    chkFlagAbnormal: TCheckBox;
    chkStatusOrder: TCheckBox;
    chkStatusSignature: TCheckBox;
    GroupBox4: TGroupBox;
    chkProvider: TCheckBox;
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    shpWizard: TShape;
    radTypeService: TRadioButton;
    chkTypeOrder: TCheckBox;
    chkNoOrders: TCheckBox;
    Label4: TLabel;
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnFinishClick(Sender: TObject);
    procedure chkCriterionClick(Sender: TObject);
    procedure radTypeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkTypeOrderClick(Sender: TObject);
  private
    FCreating: Boolean;
  public
    { Public declarations }
  end;

var
  frmPageOrders: TfrmPageOrders;

implementation

uses fHost, uReport, fPageSaveto;

{$R *.DFM}

{ Private Procedures and Events ------------------------------------------------------------ }

{ Create and Destroy ----------------------------------------------------------------------- }

procedure TfrmPageOrders.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  FCreating := True;
  if frmHost.DriveByEdit then
    btnFinish.Enabled := True;
  for i := 0 to Pred(ComponentCount) do
  begin
    if Components[i].Tag = 0 then Continue;
    if not ((Components[i] is TCheckBox) or (Components[i] is TRadioButton)) then Continue;
    if Report.ContainsCriterion(Components[i].Tag) then
    begin
      if Components[i] is TCheckBox    then TCheckBox(Components[i]).Checked := True;
      if Components[i] is TRadioButton then TRadioButton(Components[i]).Checked := True;
    end;
  end;
  if radTypeService.Checked or radItemOrdered.Checked or radItemOrderedCombo.Checked
    then chkTypeOrder.Checked := True;
  FCreating := False;
  fraNewQuery.BuildQuery;
end;

{ Control Events --------------------------------------------------------------------------- }

{ The following code can be re-added in case it is necessary to add support for searching
  based on result date back in.

  -- add to FormCreate --
  if not (radDateStart.Checked or radDateResults.Checked) then
  begin
    radDateStart.Checked := True;
    Report.AddCriterion(radDateStart.Tag);

  -- control event for each radio button
  procedure TfrmPageOrders.radDateClick(Sender: TObject);
  begin
    if FCreating then Exit;
    if radDateStart.Checked then
    begin
      Report.RemoveCriterion(radDateResults.Tag);
      Report.AddCriterion(radDateStart.Tag);
    end else
    begin
      Report.RemoveCriterion(radDateStart.Tag);
      Report.AddCriterion(radDateResults.Tag);
    end;
    fraNewQuery.BuildQuery;
  end;
}

procedure TfrmPageOrders.chkTypeOrderClick(Sender: TObject);
begin
  if FCreating then Exit;
  if chkTypeOrder.Checked then
  begin
    if not (radTypeService.Checked or radItemOrdered.Checked or radItemOrderedCombo.Checked)
      then radTypeService.Checked := True;
  end else
  begin
    radTypeService.Checked      := False;
    radItemOrdered.Checked      := False;
    radItemOrderedCombo.Checked := False;
    Report.RemoveCriterion(radTypeService.Tag);
    Report.RemoveCriterion(radItemOrdered.Tag);
    Report.RemoveCriterion(radItemOrderedCombo.Tag);
    fraNewQuery.BuildQuery;
  end;
end;

procedure TfrmPageOrders.radTypeClick(Sender: TObject);
begin
  if FCreating then Exit;
  chkTypeOrder.Checked := True;
  if radTypeService.Checked
    then Report.AddCriterion(radTypeService.Tag)
    else Report.RemoveCriterion(radTypeService.Tag);
  if radItemOrdered.Checked
    then Report.AddCriterion(radItemOrdered.Tag)
    else Report.RemoveCriterion(radItemOrdered.Tag);
  if radItemOrderedCombo.Checked
    then Report.AddCriterion(radItemOrderedCombo.Tag)
    else Report.RemoveCriterion(radItemOrderedCombo.Tag);
  fraNewQuery.BuildQuery;
end;

procedure TfrmPageOrders.chkCriterionClick(Sender: TObject);
begin
  if FCreating then Exit;
  with Sender as TCheckBox do
    if Checked then Report.AddCriterion(Tag)
    else Report.RemoveCriterion(Tag);
  fraNewQuery.BuildQuery;
end;

{ Button Events ---------------------------------------------------------------------------- }

procedure TfrmPageOrders.btnCancelClick(Sender: TObject);
begin
  Report.Clear;
  OldQuery.Clear;
  frmHost.DriveByEdit := False;
  frmHost.SwitchTo(CONTENT_REPORTS);
end;

procedure TfrmPageOrders.btnBackClick(Sender: TObject);
begin
  frmHost.WizardBack;
end;

procedure TfrmPageOrders.btnNextClick(Sender: TObject);
begin
  frmHost.WizardNext
end;

procedure TfrmPageOrders.btnFinishClick(Sender: TObject);
begin
  frmHost.DriveByEdit := False;
  if IsGenericReport(Report.DisplayText) then
    SaveReportTo
  else
    SaveEditedReport;

  frmHost.SwitchTo(CONTENT_REPORTS);
end;

end.
