unit fPageVisits;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, mQuery, ExtCtrls, ComCtrls;

type
  TfrmPageVisits = class(TForm)
    pnlButtons: TPanel;
    Label2: TLabel;
    Splitter1: TSplitter;
    pnlQuery: TPanel;
    Label1: TLabel;
    fraNewQuery: TfraQuery;
    btnFinish: TButton;
    btnNext: TButton;
    btnBack: TButton;
    btnCancel: TButton;
    ProgressBar1: TProgressBar;
    Label3: TLabel;
    shpWizard: TShape;
    ScrollBox1: TScrollBox;
    GroupBox4: TGroupBox;
    chkLocation: TCheckBox;
    Label4: TLabel;
    chkNoOrders: TCheckBox;
    procedure btnCancelClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnFinishClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkCriterion(Sender: TObject);
  private
    FCreating: Boolean;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

uses ORFn, fHost, uReport, fPageSaveto;

{ Create and Destroy ----------------------------------------------------------------------- }

procedure TfrmPageVisits.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  FCreating := True;
  if frmHost.DriveByEdit then
    btnFinish.Enabled := True;
  for i := 0 to Pred(ComponentCount) do
  begin
    if Components[i].Tag = 0 then Continue;
    if not ((Components[i] is TCheckBox) or (Components[i] is TRadioButton)) then Continue;
    if Report.ContainsCriterion(Components[i].Tag) then
    begin
      if Components[i] is TCheckBox    then TCheckBox(Components[i]).Checked := True;
      if Components[i] is TRadioButton then TRadioButton(Components[i]).Checked := True;
    end;
  end;
  FCreating := False;
  fraNewQuery.BuildQuery;
end;

{ Control Events --------------------------------------------------------------------------- }

procedure TfrmPageVisits.chkCriterion(Sender: TObject);
begin
  if FCreating then Exit;
  with Sender as TCheckBox do
  begin
    if Checked
      then Report.AddCriterion(Tag)
      else Report.RemoveCriterion(Tag);
  end;
  fraNewQuery.BuildQuery;
end;

{ Button Events ---------------------------------------------------------------------------- }

procedure TfrmPageVisits.btnCancelClick(Sender: TObject);
begin
  Report.Clear;
  OldQuery.Clear;
  frmHost.DriveByEdit := False;
  frmHost.SwitchTo(CONTENT_REPORTS);
end;

procedure TfrmPageVisits.btnBackClick(Sender: TObject);
begin
  frmHost.WizardBack;
end;

procedure TfrmPageVisits.btnNextClick(Sender: TObject);
begin
  frmHost.WizardNext;
end;

procedure TfrmPageVisits.btnFinishClick(Sender: TObject);
begin
  frmHost.DriveByEdit := False;
  if IsGenericReport(Report.DisplayText) then
    SaveReportTo
  else
    SaveEditedReport;
  frmHost.SwitchTo(CONTENT_REPORTS);
end;

end.
