unit fpageSaveTo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ORCtrls;

type
  TfrmPageSaveTo = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    edtReportName: TEdit;
    lstCurReports: TORListBox;
    Panel2: TPanel;
    btnSave: TButton;
    btnCancel: TButton;
    btnView: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnViewClick(Sender: TObject);
    procedure edtReportNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    FExistedRPTList: TStringList;
  public
    { Public declarations }
  end;

procedure SaveReportTo;

implementation

uses uReport, rReport, ORFn;
{$R *.dfm}

procedure SaveReportTo;
var
  frmPageSaveTo: TfrmPageSaveTo;
begin
  frmPageSaveTo := TfrmPageSaveTo.Create(nil);
  try
    frmPageSaveTo.ShowModal;
  finally
    frmPageSaveTo.Release;
  end;
end;

procedure TfrmPageSaveTo.FormCreate(Sender: TObject);
var
  i: integer;
begin
  FExistedRPTList := TStringList.Create;
  Report.ListNamesByUser(FExistedRPTList);
  for i := 0 to Pred(FExistedRPTList.Count) do
  begin
    if Piece(FExistedRPTList[i], U, 1) <> '0' then
      lstCurReports.AddItem(Piece(FExistedRPTList[i],'^',2),nil)
    else begin
      lstCurReports.AddItem('Create Custom Search...',nil);
      lstCurReports.AddItem('  ',nil);
    end;
  end;
  ClientHeight := panel1.Height + panel2.Height;
end;

procedure TfrmPageSaveTo.btnSaveClick(Sender: TObject);
const
  TX_NO_UPARR  = 'The report name is not valid. You can not use "^" in a report name.';
  TC_NO_UPARR  = 'Invalid Report Name';
  TX_NO_SAVE   = 'Can not save the report. You need to enter a report name first.';
  TC_NO_SAVE   = 'Error saving report';
  TX_DUP       = 'The report name you entered was already used. Pleas re-enter the report name.';
  TC_DUP       = 'Duplicated report name';
var
  TempRPT: TReport;
begin
  if ShowMsgOn( Length(edtReportName.Text)<1 ,TX_NO_SAVE, TC_NO_SAVE) then
  begin
    ActiveControl := edtReportName;
    Exit;
  end;

  if ShowMsgOn((Pos('^',edtReportName.Text)>0),TX_NO_UPARR, TC_NO_UPARR) then
  begin
    edtReportName.Text := '';
    ActiveControl := edtReportName;
    Exit;
  end;

  if ShowMsgOn(lstCurReports.Items.IndexOf(edtReportName.Text)>-1, TX_DUP, TC_DUP) then
  begin
    edtReportName.Text := '';
    ActiveControl := edtReportName;
    Exit;
  end;

  if Trim(Copy(Report.Name,1,4)) <> 'RPT' then
  begin
    // save a user report to a new user report
    TempRPT             := TReport.Create;
    TempRPT.Id          := 0;
    TempRPT.DisplayText := edtReportName.Text;
    TempRPT.QueryList   := Report.QueryList;
    TempRPT.ColList     := Report.ColList;
    TempRPT.Save(True);
    Report.Clear;
    Report := TempRPT;
  end else
  begin
    // save a generic report to a new user report
    Report.DisplayText :=  edtReportName.Text;
    Report.Save(True);
  end;
  Close;
end;

procedure TfrmPageSaveTo.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPageSaveTo.btnViewClick(Sender: TObject);
const
  CAP0 = 'Click to review your current report list';
  CAP1 = 'Click to hide your current report list';
begin
  if btnView.Tag = 0 then
  begin
    ClientHeight := panel1.Height + panel2.Height + lstCurReports.Height;
    lstCurReports.Visible := True;
    btnView.Caption := CAP1;
    btnView.Tag := 1;
  end
  else if btnView.Tag = 1 then
  begin
    lstCurReports.Visible := False;
    btnView.Caption := CAP0;
    btnView.Tag := 0;
    ClientHeight := panel1.Height + panel2.Height;
  end;
end;

procedure TfrmPageSaveTo.edtReportNameKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_RETURN then
     btnSaveClick(Self);
end;

end.


