unit uReportUnitTest;

interface

uses SysUtils, Classes, TestFrameWork, uReport;

type
  TReportUnitTest = class(TTestCase)
  private
    FReport: TReport;
  protected
    procedure Setup; override;
    procedure TearDown; override;
  published
    procedure TestCreate;
    procedure TestFillReportList;
    procedure TestSetReportDefinition;
    procedure TestFillCriteriaList;
    procedure TestQueryTextReport;
    procedure TestQueryTextCriterion;
  end;

implementation

{ TReportUnitTest }

procedure TReportUnitTest.Setup;
begin
  inherited;
  FReport := TReport.Create;
end;

procedure TReportUnitTest.TearDown;
begin
  inherited;
  FReport.Free;
end;

procedure TReportUnitTest.TestCreate;
begin
  Check(FReport <> nil);
  Check(FReport.Name = '');
end;

procedure TReportUnitTest.TestFillReportList;
var
  AStringList: TStringList;
begin
  AStringList := TStringList.Create;
  FReport.FillReportList(AStringList);
  Check(AStringList.Count = 6);
  Check(AStringList[0] = '17^Abnormal Results');
  Check(AStringList[5] = '16^Test Constraint Editors');
  AStringList.Free;
end;

procedure TReportUnitTest.TestSetReportDefinition;
var
  i: Integer;
begin
  FReport.SetReportDefinition(16);
  Check(FReport.Name = 'RPT TEST EDITORS');
  Check(FReport.QueryText[0].Caption = 'For patients');
  Check(FReport.QueryText[0].ConstraintName = '');
  Check(FReport.QueryText[0].CriterionID = 12);
  Check(FReport.QueryText[0].EditorID = 0);
  Check(FReport.QueryText[0].Values.Count = 0);
  i := 0;
  repeat
    Inc(i);
  until FReport.QueryText[i] = nil;
  Check(i = 27, 'query text count:' + IntToStr(i));
  //TODO: test query text entries
  //TODO: test edit of caption and value
end;

procedure TReportUnitTest.TestFillCriteriaList;
begin

end;

procedure TReportUnitTest.TestQueryTextCriterion;
begin

end;

procedure TReportUnitTest.TestQueryTextReport;
begin

end;

initialization
  TestFramework.RegisterTest(TReportUnitTest.Suite);

end.

